// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateNamespaceServiceParams creates a new CreateNamespaceServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateNamespaceServiceParams() *CreateNamespaceServiceParams {
	return &CreateNamespaceServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateNamespaceServiceParamsWithTimeout creates a new CreateNamespaceServiceParams object
// with the ability to set a timeout on a request.
func NewCreateNamespaceServiceParamsWithTimeout(timeout time.Duration) *CreateNamespaceServiceParams {
	return &CreateNamespaceServiceParams{
		timeout: timeout,
	}
}

// NewCreateNamespaceServiceParamsWithContext creates a new CreateNamespaceServiceParams object
// with the ability to set a context for a request.
func NewCreateNamespaceServiceParamsWithContext(ctx context.Context) *CreateNamespaceServiceParams {
	return &CreateNamespaceServiceParams{
		Context: ctx,
	}
}

// NewCreateNamespaceServiceParamsWithHTTPClient creates a new CreateNamespaceServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateNamespaceServiceParamsWithHTTPClient(client *http.Client) *CreateNamespaceServiceParams {
	return &CreateNamespaceServiceParams{
		HTTPClient: client,
	}
}

/* CreateNamespaceServiceParams contains all the parameters to send to the API endpoint
   for the create namespace service operation.

   Typically these are written to a http.Request.
*/
type CreateNamespaceServiceParams struct {

	/* Service.

	   Payload that contains information on new service
	*/
	Service CreateNamespaceServiceBody

	/* Namespace.

	   target namespace
	*/
	Namespace string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create namespace service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateNamespaceServiceParams) WithDefaults() *CreateNamespaceServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create namespace service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateNamespaceServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create namespace service params
func (o *CreateNamespaceServiceParams) WithTimeout(timeout time.Duration) *CreateNamespaceServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create namespace service params
func (o *CreateNamespaceServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create namespace service params
func (o *CreateNamespaceServiceParams) WithContext(ctx context.Context) *CreateNamespaceServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create namespace service params
func (o *CreateNamespaceServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create namespace service params
func (o *CreateNamespaceServiceParams) WithHTTPClient(client *http.Client) *CreateNamespaceServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create namespace service params
func (o *CreateNamespaceServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithService adds the service to the create namespace service params
func (o *CreateNamespaceServiceParams) WithService(service CreateNamespaceServiceBody) *CreateNamespaceServiceParams {
	o.SetService(service)
	return o
}

// SetService adds the service to the create namespace service params
func (o *CreateNamespaceServiceParams) SetService(service CreateNamespaceServiceBody) {
	o.Service = service
}

// WithNamespace adds the namespace to the create namespace service params
func (o *CreateNamespaceServiceParams) WithNamespace(namespace string) *CreateNamespaceServiceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the create namespace service params
func (o *CreateNamespaceServiceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WriteToRequest writes these params to a swagger request
func (o *CreateNamespaceServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Service); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
