// Code generated by go-swagger; DO NOT EDIT.

package workflows

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateWorkflowParams creates a new CreateWorkflowParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateWorkflowParams() *CreateWorkflowParams {
	return &CreateWorkflowParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateWorkflowParamsWithTimeout creates a new CreateWorkflowParams object
// with the ability to set a timeout on a request.
func NewCreateWorkflowParamsWithTimeout(timeout time.Duration) *CreateWorkflowParams {
	return &CreateWorkflowParams{
		timeout: timeout,
	}
}

// NewCreateWorkflowParamsWithContext creates a new CreateWorkflowParams object
// with the ability to set a context for a request.
func NewCreateWorkflowParamsWithContext(ctx context.Context) *CreateWorkflowParams {
	return &CreateWorkflowParams{
		Context: ctx,
	}
}

// NewCreateWorkflowParamsWithHTTPClient creates a new CreateWorkflowParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateWorkflowParamsWithHTTPClient(client *http.Client) *CreateWorkflowParams {
	return &CreateWorkflowParams{
		HTTPClient: client,
	}
}

/* CreateWorkflowParams contains all the parameters to send to the API endpoint
   for the create workflow operation.

   Typically these are written to a http.Request.
*/
type CreateWorkflowParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Op.

	   the operation for the api

	   Default: "create-workflow"
	*/
	Op string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	/* WorkflowData.

	   Payload that contains the direktiv workflow yaml to create.
	*/
	WorkflowData string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create workflow params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateWorkflowParams) WithDefaults() *CreateWorkflowParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create workflow params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateWorkflowParams) SetDefaults() {
	var (
		opDefault = string("create-workflow")
	)

	val := CreateWorkflowParams{
		Op: opDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the create workflow params
func (o *CreateWorkflowParams) WithTimeout(timeout time.Duration) *CreateWorkflowParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create workflow params
func (o *CreateWorkflowParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create workflow params
func (o *CreateWorkflowParams) WithContext(ctx context.Context) *CreateWorkflowParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create workflow params
func (o *CreateWorkflowParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create workflow params
func (o *CreateWorkflowParams) WithHTTPClient(client *http.Client) *CreateWorkflowParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create workflow params
func (o *CreateWorkflowParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the create workflow params
func (o *CreateWorkflowParams) WithNamespace(namespace string) *CreateWorkflowParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the create workflow params
func (o *CreateWorkflowParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithOp adds the op to the create workflow params
func (o *CreateWorkflowParams) WithOp(op string) *CreateWorkflowParams {
	o.SetOp(op)
	return o
}

// SetOp adds the op to the create workflow params
func (o *CreateWorkflowParams) SetOp(op string) {
	o.Op = op
}

// WithWorkflow adds the workflow to the create workflow params
func (o *CreateWorkflowParams) WithWorkflow(workflow string) *CreateWorkflowParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the create workflow params
func (o *CreateWorkflowParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WithWorkflowData adds the workflowData to the create workflow params
func (o *CreateWorkflowParams) WithWorkflowData(workflowData string) *CreateWorkflowParams {
	o.SetWorkflowData(workflowData)
	return o
}

// SetWorkflowData adds the workflowData to the create workflow params
func (o *CreateWorkflowParams) SetWorkflowData(workflowData string) {
	o.WorkflowData = workflowData
}

// WriteToRequest writes these params to a swagger request
func (o *CreateWorkflowParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// query param op
	qrOp := o.Op
	qOp := qrOp
	if qOp != "" {

		if err := r.SetQueryParam("op", qOp); err != nil {
			return err
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}
	if err := r.SetBodyParam(o.WorkflowData); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
