// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/pkg/flow/ent/cloudevents"
	"github.com/direktiv/direktiv/pkg/flow/ent/events"
	"github.com/direktiv/direktiv/pkg/flow/ent/inode"
	"github.com/direktiv/direktiv/pkg/flow/ent/instance"
	"github.com/direktiv/direktiv/pkg/flow/ent/logmsg"
	"github.com/direktiv/direktiv/pkg/flow/ent/mirror"
	"github.com/direktiv/direktiv/pkg/flow/ent/mirroractivity"
	"github.com/direktiv/direktiv/pkg/flow/ent/namespace"
	"github.com/direktiv/direktiv/pkg/flow/ent/predicate"
	"github.com/direktiv/direktiv/pkg/flow/ent/varref"
	"github.com/direktiv/direktiv/pkg/flow/ent/workflow"
	"github.com/google/uuid"
)

// NamespaceQuery is the builder for querying Namespace entities.
type NamespaceQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.Namespace
	// eager-loading edges.
	withInodes             *InodeQuery
	withWorkflows          *WorkflowQuery
	withMirrors            *MirrorQuery
	withMirrorActivities   *MirrorActivityQuery
	withInstances          *InstanceQuery
	withLogs               *LogMsgQuery
	withVars               *VarRefQuery
	withCloudevents        *CloudEventsQuery
	withNamespacelisteners *EventsQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the NamespaceQuery builder.
func (nq *NamespaceQuery) Where(ps ...predicate.Namespace) *NamespaceQuery {
	nq.predicates = append(nq.predicates, ps...)
	return nq
}

// Limit adds a limit step to the query.
func (nq *NamespaceQuery) Limit(limit int) *NamespaceQuery {
	nq.limit = &limit
	return nq
}

// Offset adds an offset step to the query.
func (nq *NamespaceQuery) Offset(offset int) *NamespaceQuery {
	nq.offset = &offset
	return nq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (nq *NamespaceQuery) Unique(unique bool) *NamespaceQuery {
	nq.unique = &unique
	return nq
}

// Order adds an order step to the query.
func (nq *NamespaceQuery) Order(o ...OrderFunc) *NamespaceQuery {
	nq.order = append(nq.order, o...)
	return nq
}

// QueryInodes chains the current query on the "inodes" edge.
func (nq *NamespaceQuery) QueryInodes() *InodeQuery {
	query := &InodeQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(inode.Table, inode.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.InodesTable, namespace.InodesColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryWorkflows chains the current query on the "workflows" edge.
func (nq *NamespaceQuery) QueryWorkflows() *WorkflowQuery {
	query := &WorkflowQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(workflow.Table, workflow.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.WorkflowsTable, namespace.WorkflowsColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryMirrors chains the current query on the "mirrors" edge.
func (nq *NamespaceQuery) QueryMirrors() *MirrorQuery {
	query := &MirrorQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(mirror.Table, mirror.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.MirrorsTable, namespace.MirrorsColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryMirrorActivities chains the current query on the "mirror_activities" edge.
func (nq *NamespaceQuery) QueryMirrorActivities() *MirrorActivityQuery {
	query := &MirrorActivityQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(mirroractivity.Table, mirroractivity.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.MirrorActivitiesTable, namespace.MirrorActivitiesColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryInstances chains the current query on the "instances" edge.
func (nq *NamespaceQuery) QueryInstances() *InstanceQuery {
	query := &InstanceQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(instance.Table, instance.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.InstancesTable, namespace.InstancesColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryLogs chains the current query on the "logs" edge.
func (nq *NamespaceQuery) QueryLogs() *LogMsgQuery {
	query := &LogMsgQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(logmsg.Table, logmsg.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.LogsTable, namespace.LogsColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryVars chains the current query on the "vars" edge.
func (nq *NamespaceQuery) QueryVars() *VarRefQuery {
	query := &VarRefQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(varref.Table, varref.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.VarsTable, namespace.VarsColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryCloudevents chains the current query on the "cloudevents" edge.
func (nq *NamespaceQuery) QueryCloudevents() *CloudEventsQuery {
	query := &CloudEventsQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(cloudevents.Table, cloudevents.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.CloudeventsTable, namespace.CloudeventsColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryNamespacelisteners chains the current query on the "namespacelisteners" edge.
func (nq *NamespaceQuery) QueryNamespacelisteners() *EventsQuery {
	query := &EventsQuery{config: nq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := nq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(namespace.Table, namespace.FieldID, selector),
			sqlgraph.To(events.Table, events.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, namespace.NamespacelistenersTable, namespace.NamespacelistenersColumn),
		)
		fromU = sqlgraph.SetNeighbors(nq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Namespace entity from the query.
// Returns a *NotFoundError when no Namespace was found.
func (nq *NamespaceQuery) First(ctx context.Context) (*Namespace, error) {
	nodes, err := nq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{namespace.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (nq *NamespaceQuery) FirstX(ctx context.Context) *Namespace {
	node, err := nq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Namespace ID from the query.
// Returns a *NotFoundError when no Namespace ID was found.
func (nq *NamespaceQuery) FirstID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = nq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{namespace.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (nq *NamespaceQuery) FirstIDX(ctx context.Context) uuid.UUID {
	id, err := nq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Namespace entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Namespace entity is found.
// Returns a *NotFoundError when no Namespace entities are found.
func (nq *NamespaceQuery) Only(ctx context.Context) (*Namespace, error) {
	nodes, err := nq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{namespace.Label}
	default:
		return nil, &NotSingularError{namespace.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (nq *NamespaceQuery) OnlyX(ctx context.Context) *Namespace {
	node, err := nq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Namespace ID in the query.
// Returns a *NotSingularError when more than one Namespace ID is found.
// Returns a *NotFoundError when no entities are found.
func (nq *NamespaceQuery) OnlyID(ctx context.Context) (id uuid.UUID, err error) {
	var ids []uuid.UUID
	if ids, err = nq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{namespace.Label}
	default:
		err = &NotSingularError{namespace.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (nq *NamespaceQuery) OnlyIDX(ctx context.Context) uuid.UUID {
	id, err := nq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Namespaces.
func (nq *NamespaceQuery) All(ctx context.Context) ([]*Namespace, error) {
	if err := nq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return nq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (nq *NamespaceQuery) AllX(ctx context.Context) []*Namespace {
	nodes, err := nq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Namespace IDs.
func (nq *NamespaceQuery) IDs(ctx context.Context) ([]uuid.UUID, error) {
	var ids []uuid.UUID
	if err := nq.Select(namespace.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (nq *NamespaceQuery) IDsX(ctx context.Context) []uuid.UUID {
	ids, err := nq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (nq *NamespaceQuery) Count(ctx context.Context) (int, error) {
	if err := nq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return nq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (nq *NamespaceQuery) CountX(ctx context.Context) int {
	count, err := nq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (nq *NamespaceQuery) Exist(ctx context.Context) (bool, error) {
	if err := nq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return nq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (nq *NamespaceQuery) ExistX(ctx context.Context) bool {
	exist, err := nq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the NamespaceQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (nq *NamespaceQuery) Clone() *NamespaceQuery {
	if nq == nil {
		return nil
	}
	return &NamespaceQuery{
		config:                 nq.config,
		limit:                  nq.limit,
		offset:                 nq.offset,
		order:                  append([]OrderFunc{}, nq.order...),
		predicates:             append([]predicate.Namespace{}, nq.predicates...),
		withInodes:             nq.withInodes.Clone(),
		withWorkflows:          nq.withWorkflows.Clone(),
		withMirrors:            nq.withMirrors.Clone(),
		withMirrorActivities:   nq.withMirrorActivities.Clone(),
		withInstances:          nq.withInstances.Clone(),
		withLogs:               nq.withLogs.Clone(),
		withVars:               nq.withVars.Clone(),
		withCloudevents:        nq.withCloudevents.Clone(),
		withNamespacelisteners: nq.withNamespacelisteners.Clone(),
		// clone intermediate query.
		sql:    nq.sql.Clone(),
		path:   nq.path,
		unique: nq.unique,
	}
}

// WithInodes tells the query-builder to eager-load the nodes that are connected to
// the "inodes" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithInodes(opts ...func(*InodeQuery)) *NamespaceQuery {
	query := &InodeQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withInodes = query
	return nq
}

// WithWorkflows tells the query-builder to eager-load the nodes that are connected to
// the "workflows" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithWorkflows(opts ...func(*WorkflowQuery)) *NamespaceQuery {
	query := &WorkflowQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withWorkflows = query
	return nq
}

// WithMirrors tells the query-builder to eager-load the nodes that are connected to
// the "mirrors" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithMirrors(opts ...func(*MirrorQuery)) *NamespaceQuery {
	query := &MirrorQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withMirrors = query
	return nq
}

// WithMirrorActivities tells the query-builder to eager-load the nodes that are connected to
// the "mirror_activities" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithMirrorActivities(opts ...func(*MirrorActivityQuery)) *NamespaceQuery {
	query := &MirrorActivityQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withMirrorActivities = query
	return nq
}

// WithInstances tells the query-builder to eager-load the nodes that are connected to
// the "instances" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithInstances(opts ...func(*InstanceQuery)) *NamespaceQuery {
	query := &InstanceQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withInstances = query
	return nq
}

// WithLogs tells the query-builder to eager-load the nodes that are connected to
// the "logs" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithLogs(opts ...func(*LogMsgQuery)) *NamespaceQuery {
	query := &LogMsgQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withLogs = query
	return nq
}

// WithVars tells the query-builder to eager-load the nodes that are connected to
// the "vars" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithVars(opts ...func(*VarRefQuery)) *NamespaceQuery {
	query := &VarRefQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withVars = query
	return nq
}

// WithCloudevents tells the query-builder to eager-load the nodes that are connected to
// the "cloudevents" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithCloudevents(opts ...func(*CloudEventsQuery)) *NamespaceQuery {
	query := &CloudEventsQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withCloudevents = query
	return nq
}

// WithNamespacelisteners tells the query-builder to eager-load the nodes that are connected to
// the "namespacelisteners" edge. The optional arguments are used to configure the query builder of the edge.
func (nq *NamespaceQuery) WithNamespacelisteners(opts ...func(*EventsQuery)) *NamespaceQuery {
	query := &EventsQuery{config: nq.config}
	for _, opt := range opts {
		opt(query)
	}
	nq.withNamespacelisteners = query
	return nq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Namespace.Query().
//		GroupBy(namespace.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (nq *NamespaceQuery) GroupBy(field string, fields ...string) *NamespaceGroupBy {
	grbuild := &NamespaceGroupBy{config: nq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := nq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return nq.sqlQuery(ctx), nil
	}
	grbuild.label = namespace.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.Namespace.Query().
//		Select(namespace.FieldCreatedAt).
//		Scan(ctx, &v)
//
func (nq *NamespaceQuery) Select(fields ...string) *NamespaceSelect {
	nq.fields = append(nq.fields, fields...)
	selbuild := &NamespaceSelect{NamespaceQuery: nq}
	selbuild.label = namespace.Label
	selbuild.flds, selbuild.scan = &nq.fields, selbuild.Scan
	return selbuild
}

func (nq *NamespaceQuery) prepareQuery(ctx context.Context) error {
	for _, f := range nq.fields {
		if !namespace.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if nq.path != nil {
		prev, err := nq.path(ctx)
		if err != nil {
			return err
		}
		nq.sql = prev
	}
	return nil
}

func (nq *NamespaceQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Namespace, error) {
	var (
		nodes       = []*Namespace{}
		_spec       = nq.querySpec()
		loadedTypes = [9]bool{
			nq.withInodes != nil,
			nq.withWorkflows != nil,
			nq.withMirrors != nil,
			nq.withMirrorActivities != nil,
			nq.withInstances != nil,
			nq.withLogs != nil,
			nq.withVars != nil,
			nq.withCloudevents != nil,
			nq.withNamespacelisteners != nil,
		}
	)
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*Namespace).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &Namespace{config: nq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, nq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := nq.withInodes; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Inodes = []*Inode{}
		}
		query.withFKs = true
		query.Where(predicate.Inode(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.InodesColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_inodes
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_inodes" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_inodes" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Inodes = append(node.Edges.Inodes, n)
		}
	}

	if query := nq.withWorkflows; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Workflows = []*Workflow{}
		}
		query.withFKs = true
		query.Where(predicate.Workflow(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.WorkflowsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_workflows
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_workflows" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_workflows" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Workflows = append(node.Edges.Workflows, n)
		}
	}

	if query := nq.withMirrors; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Mirrors = []*Mirror{}
		}
		query.withFKs = true
		query.Where(predicate.Mirror(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.MirrorsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_mirrors
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_mirrors" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_mirrors" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Mirrors = append(node.Edges.Mirrors, n)
		}
	}

	if query := nq.withMirrorActivities; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.MirrorActivities = []*MirrorActivity{}
		}
		query.withFKs = true
		query.Where(predicate.MirrorActivity(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.MirrorActivitiesColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_mirror_activities
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_mirror_activities" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_mirror_activities" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.MirrorActivities = append(node.Edges.MirrorActivities, n)
		}
	}

	if query := nq.withInstances; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Instances = []*Instance{}
		}
		query.withFKs = true
		query.Where(predicate.Instance(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.InstancesColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_instances
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_instances" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_instances" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Instances = append(node.Edges.Instances, n)
		}
	}

	if query := nq.withLogs; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Logs = []*LogMsg{}
		}
		query.withFKs = true
		query.Where(predicate.LogMsg(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.LogsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_logs
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_logs" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_logs" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Logs = append(node.Edges.Logs, n)
		}
	}

	if query := nq.withVars; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Vars = []*VarRef{}
		}
		query.withFKs = true
		query.Where(predicate.VarRef(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.VarsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_vars
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_vars" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_vars" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Vars = append(node.Edges.Vars, n)
		}
	}

	if query := nq.withCloudevents; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Cloudevents = []*CloudEvents{}
		}
		query.withFKs = true
		query.Where(predicate.CloudEvents(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.CloudeventsColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_cloudevents
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_cloudevents" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_cloudevents" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Cloudevents = append(node.Edges.Cloudevents, n)
		}
	}

	if query := nq.withNamespacelisteners; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[uuid.UUID]*Namespace)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Namespacelisteners = []*Events{}
		}
		query.withFKs = true
		query.Where(predicate.Events(func(s *sql.Selector) {
			s.Where(sql.InValues(namespace.NamespacelistenersColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.namespace_namespacelisteners
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "namespace_namespacelisteners" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "namespace_namespacelisteners" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Namespacelisteners = append(node.Edges.Namespacelisteners, n)
		}
	}

	return nodes, nil
}

func (nq *NamespaceQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := nq.querySpec()
	_spec.Node.Columns = nq.fields
	if len(nq.fields) > 0 {
		_spec.Unique = nq.unique != nil && *nq.unique
	}
	return sqlgraph.CountNodes(ctx, nq.driver, _spec)
}

func (nq *NamespaceQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := nq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (nq *NamespaceQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   namespace.Table,
			Columns: namespace.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: namespace.FieldID,
			},
		},
		From:   nq.sql,
		Unique: true,
	}
	if unique := nq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := nq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, namespace.FieldID)
		for i := range fields {
			if fields[i] != namespace.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := nq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := nq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := nq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := nq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (nq *NamespaceQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(nq.driver.Dialect())
	t1 := builder.Table(namespace.Table)
	columns := nq.fields
	if len(columns) == 0 {
		columns = namespace.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if nq.sql != nil {
		selector = nq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if nq.unique != nil && *nq.unique {
		selector.Distinct()
	}
	for _, p := range nq.predicates {
		p(selector)
	}
	for _, p := range nq.order {
		p(selector)
	}
	if offset := nq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := nq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// NamespaceGroupBy is the group-by builder for Namespace entities.
type NamespaceGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (ngb *NamespaceGroupBy) Aggregate(fns ...AggregateFunc) *NamespaceGroupBy {
	ngb.fns = append(ngb.fns, fns...)
	return ngb
}

// Scan applies the group-by query and scans the result into the given value.
func (ngb *NamespaceGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := ngb.path(ctx)
	if err != nil {
		return err
	}
	ngb.sql = query
	return ngb.sqlScan(ctx, v)
}

func (ngb *NamespaceGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range ngb.fields {
		if !namespace.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := ngb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ngb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (ngb *NamespaceGroupBy) sqlQuery() *sql.Selector {
	selector := ngb.sql.Select()
	aggregation := make([]string, 0, len(ngb.fns))
	for _, fn := range ngb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(ngb.fields)+len(ngb.fns))
		for _, f := range ngb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(ngb.fields...)...)
}

// NamespaceSelect is the builder for selecting fields of Namespace entities.
type NamespaceSelect struct {
	*NamespaceQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (ns *NamespaceSelect) Scan(ctx context.Context, v interface{}) error {
	if err := ns.prepareQuery(ctx); err != nil {
		return err
	}
	ns.sql = ns.NamespaceQuery.sqlQuery(ctx)
	return ns.sqlScan(ctx, v)
}

func (ns *NamespaceSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := ns.sql.Query()
	if err := ns.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
