// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"

	"entgo.io/ent/dialect/sql"
	"github.com/direktiv/direktiv/pkg/functions/ent/services"
)

// Services is the model entity for the Services schema.
type Services struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Name holds the value of the "name" field.
	Name string `json:"name,omitempty"`
	// Data holds the value of the "data" field.
	Data string `json:"data,omitempty"`
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Services) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case services.FieldID:
			values[i] = new(sql.NullInt64)
		case services.FieldName, services.FieldData:
			values[i] = new(sql.NullString)
		default:
			return nil, fmt.Errorf("unexpected column %q for type Services", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Services fields.
func (s *Services) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case services.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			s.ID = int(value.Int64)
		case services.FieldName:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field name", values[i])
			} else if value.Valid {
				s.Name = value.String
			}
		case services.FieldData:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field data", values[i])
			} else if value.Valid {
				s.Data = value.String
			}
		}
	}
	return nil
}

// Update returns a builder for updating this Services.
// Note that you need to call Services.Unwrap() before calling this method if this Services
// was returned from a transaction, and the transaction was committed or rolled back.
func (s *Services) Update() *ServicesUpdateOne {
	return (&ServicesClient{config: s.config}).UpdateOne(s)
}

// Unwrap unwraps the Services entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (s *Services) Unwrap() *Services {
	_tx, ok := s.config.driver.(*txDriver)
	if !ok {
		panic("ent: Services is not a transactional entity")
	}
	s.config.driver = _tx.drv
	return s
}

// String implements the fmt.Stringer.
func (s *Services) String() string {
	var builder strings.Builder
	builder.WriteString("Services(")
	builder.WriteString(fmt.Sprintf("id=%v, ", s.ID))
	builder.WriteString("name=")
	builder.WriteString(s.Name)
	builder.WriteString(", ")
	builder.WriteString("data=")
	builder.WriteString(s.Data)
	builder.WriteByte(')')
	return builder.String()
}

// ServicesSlice is a parsable slice of Services.
type ServicesSlice []*Services

func (s ServicesSlice) config(cfg config) {
	for _i := range s {
		s[_i].config = cfg
	}
}
